abstract class Set {
	public abstract Object [] toArray();
	public abstract void add(Object o);
	public abstract boolean isMember(Object o);
	public abstract String toString();
	public boolean equals(Object o){
		Set s2 = (Set)o;
		Object [] other = s2.toArray();
		Object [] mine = toArray();
		for(Object item:other){ if(!isMember(item)) return false;}
		for(Object item:mine){ if(!s2.isMember(item)) return false;}
		return true;
	}
}

class ListSet extends Set {
	ListSet next;
	Object o;
	int taille;
	public Object [] toArray(){
		if(taille <=0) return null;
		Object [] res = new Object[taille];
		int i=0;
		for(ListSet t=this; t!=null; t=t.next)
			res[i++] = t.o;
		return res;
	}
	public void add(Object o){
		if(isMember(o)) return;
		if(this.o == null){ this.o = o; taille=1; return; }
		ListSet ls = new ListSet();
		ls.o = o;
		ls.next = next;
		next = ls;
		taille++;
	}
	public boolean isMember(Object o){
		if(o==null) return false;
		for(ListSet t=this; t!=null; t=t.next)
			if(o.equals(t.o)) return true;
		return false;
	}
	public String toString(){
		Object data [] = toArray();
		String s="";
		for(Object o:data)
			s = s+o.toString()+", ";
		return s;
	}
	public boolean isEmpty(){ return o==null; }

	public static void main(String [] args){
		Set s1 = new ListSet();
		s1.add(1);
		s1.add(5);
		s1.add(7);
		s1.add(2);
		s1.add("hi");
		Set s2 = new ListSet();
		s2.add(1);
		s2.add(2);
		s2.add(7);
		s2.add(5);
		s2.add("hi");
		System.out.println(s1);
		System.out.println(s2);
		System.out.println(s1.equals(s2));
		System.out.println(s2.equals(s1));
	}
}
